unit Main;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Globs, ExtCtrls, Buttons,
  Menus, Spin, Lynx10Ctrls, ComCtrls, lynx10;

type
  TMainForm = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    MainMenu1: TMainMenu;
    CommPort1: TMenuItem;
    Com1: TMenuItem;
    Com2: TMenuItem;
    Com3: TMenuItem;
    Com4: TMenuItem;
    N1: TMenuItem;
    TxCommands: TListBox;
    RxCommands: TListBox;
    Lynx10Errors1: TMenuItem;
    BadCommandsFromHost1: TMenuItem;
    BadDataFromHost1: TMenuItem;
    X10CollisionsDetected1: TMenuItem;
    X10TransmissionFailure1: TMenuItem;
    X10LostReception1: TMenuItem;
    SerialReceiveBufferOverRun1: TMenuItem;
    LostCarrrier1: TMenuItem;
    ClearLynx10Erros1: TMenuItem;
    BadCommandsFromHost2: TMenuItem;
    BadDataFromHost2: TMenuItem;
    X10CollisionsDetected2: TMenuItem;
    X10TransmissionFailures1: TMenuItem;
    X10LostReception2: TMenuItem;
    SerialRecevieBufferOverRun1: TMenuItem;
    LostCarrier1: TMenuItem;
    X10ReceptionErrors1: TMenuItem;
    X10ReceptionErrors2: TMenuItem;
    Lynx10Info1: TMenuItem;
    Version1: TMenuItem;
    Copywrite1: TMenuItem;
    OnCommands1: TMenuItem;
    TurnOn1: TMenuItem;
    TurnOnHouseCode1: TMenuItem;
    TurnOnAll1: TMenuItem;
    OffCommands1: TMenuItem;
    TurnOff1: TMenuItem;
    TurnOffTurnOffHouseCodeLights1: TMenuItem;
    TurnOffAllHouseCode1: TMenuItem;
    TurnOffAllHouseCode2: TMenuItem;
    TurnOffAll1: TMenuItem;
    DimCommands1: TMenuItem;
    DimUpHousecode1: TMenuItem;
    DimDownHouseCode1: TMenuItem;
    DimTo1: TMenuItem;
    N2: TMenuItem;
    GetAllErrors1: TMenuItem;
    N3: TMenuItem;
    CelarAllErrors1: TMenuItem;
    PopupMenu1: TPopupMenu;
    ResendThisCommand1: TMenuItem;
    Panel5: TPanel;
    GetModeBtn: TBitBtn;
    Terminators: TRadioGroup;
    SetHandShakingMode: TCheckBox;
    SetDimMode: TCheckBox;
    SetDebugMode: TCheckBox;
    Panel3: TPanel;
    OffBtn: TBitBtn;
    Onbtn: TBitBtn;
    HouseCodes: TRadioGroup;
    DimToBtn: TBitBtn;
    DimAmount: TSpinEdit;
    DeviceCodes: TRadioGroup;
    ManualBtn: TBitBtn;
    CRLF: TCheckBox;
    Command: TEdit;
    Lynx10: TLynx10;
    Lynx10Trackbar1: TLynx10Trackbar;
    Version: TLabel;
    Copyright: TLabel;
    Label1: TLabel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    E8: TMenuItem;
    Panel4: TPanel;
    E0: TLabel;
    E1: TLabel;
    E2: TLabel;
    E3: TLabel;
    E4: TLabel;
    E5: TLabel;
    E6: TLabel;
    E7: TLabel;
    editE0: TEdit;
    EditE1: TEdit;
    EditE2: TEdit;
    editE5: TEdit;
    EditE4: TEdit;
    EditE3: TEdit;
    editE7: TEdit;
    editE6: TEdit;
    N4: TMenuItem;
    C1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure OnbtnClick(Sender: TObject);
    procedure Lynx10Receive(Sender: TObject);
    procedure GetModeBtnClick(Sender: TObject);
    procedure SetDimModeClick(Sender: TObject);
    procedure SetDebugModeClick(Sender: TObject);
    procedure SetHandShakingModeClick(Sender: TObject);
    procedure ManualBtnClick(Sender: TObject);
    procedure TerminatorsClick(Sender: TObject);
    procedure Lynx10Transmit(Sender: TObject);
    procedure BadCommandsFromHost1Click(Sender: TObject);
    procedure BadCommandsFromHost2Click(Sender: TObject);
    procedure Version1Click(Sender: TObject);
    procedure Copywrite1Click(Sender: TObject);
    procedure TurnOn1Click(Sender: TObject);
    procedure TurnOnHouseCode1Click(Sender: TObject);
    procedure TurnOnAll1Click(Sender: TObject);
    procedure TurnOff1Click(Sender: TObject);
    procedure TurnOffTurnOffHouseCodeLights1Click(Sender: TObject);
    procedure TurnOffAllHouseCode1Click(Sender: TObject);
    procedure TurnOffAllHouseCode2Click(Sender: TObject);
    procedure TurnOffAll1Click(Sender: TObject);
    procedure DimToBtnClick(Sender: TObject);
    procedure DimUpHousecode1Click(Sender: TObject);
    procedure DimDownHouseCode1Click(Sender: TObject);
    procedure GetAllErrors1Click(Sender: TObject);
    procedure CelarAllErrors1Click(Sender: TObject);
    procedure ResendThisCommand1Click(Sender: TObject);
    procedure Lynx10ReceiveData(Sender: TObject; Data: PChar;
      DataSize: Integer);
    procedure Lynx10TransmitData(Sender: TObject; Data: PChar;
      DataSize: Integer);
    procedure Lynx10RecErrorCount(Sender: TObject; Count, Data: integer);
    procedure Lynx10RecCopywrite(Sender: TObject);
    procedure Lynx10RecModeRegister(Sender: TObject);
    procedure Lynx10RecVersion(Sender: TObject);
    procedure E8Click(Sender: TObject);
    procedure Com1Click(Sender: TObject);
    procedure Lynx10Connect(Sender: TObject);
    procedure Lynx10DisConnect(Sender: TObject);
    procedure C1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.FormCreate(Sender: TObject);
var
  s          :string;
  tcstr      :array[0..100] of char;
  pc         :pchar;
  x          :integer;
begin
  s:=application.exename;
  strpcopy(tcstr,s);
  pc:=strrscan(tcstr,'\');
  strcopy(pc,chr(0));
  StrCopy(LocalPath,tcstr);
  StrCopy(IniFileName,LocalPath);
  StrCat(IniFileName,'\Lynx10Tester.ini');
  (* Get Window Settings *)
  MainForm.left:=GetPrivateProfileInt('App','x',0,IniFileName);
  MainForm.Top:=GetPrivateProfileInt('App','y',0,IniFileName);
  MainForm.Width:=GetPrivateProfileInt('App','w',745,IniFileName);
  MainForm.Height:=GetPrivateProfileInt('App','h',500,IniFileName);
  x10_port:=GetPrivateProfileInt('X10','Port',0,IniFileName);
  case x10_port of
    1: Lynx10.ComPort:=pn_Com1;
    2: Lynx10.ComPort:=pn_Com2;
    3: Lynx10.ComPort:=pn_Com3;
    4: Lynx10.ComPort:=pn_Com4;
  end;  (* end case *)
  if x10_port in [1..4] then
  begin
    Lynx10.Connect;
    if Lynx10.Connected then
    begin
      Lynx10.RequestModeRegister;
      Lynx10.TerminationMode:=TermWith_CR;
    end;  
  end;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
var
  tcstr      :array[0..100] of char;
begin
  (* Save Window Settings *)
  strpcopy(tcstr,inttostr(MainForm.Left));
  WritePrivateProfileString('App','x',tcstr,IniFileName);
  strpcopy(tcstr,inttostr(MainForm.Top));
  WritePrivateProfileString('App','y',tcstr,IniFileName);
  strpcopy(tcstr,inttostr(MainForm.Width));
  WritePrivateProfileString('App','w',tcstr,IniFileName);
  strpcopy(tcstr,inttostr(MainForm.Height));
  WritePrivateProfileString('App','h',tcstr,IniFileName);
  strpcopy(tcstr,inttostr(X10_Port));
  WritePrivateProfileString('X10','Port',tcstr,IniFileName);
  Lynx10.DisConnect;
end;

procedure TMainForm.OnbtnClick(Sender: TObject);
var
  h,d   :string[3];
begin
  h:=inttohex(housecodes.itemindex,1);
  d:=inttohex(devicecodes.itemindex,1);
  if (sender=OnBtn) then Lynx10.TurnOn(h,d)
  else if (sender=OffBtn) then Lynx10.TurnOff(h,d);
end;

procedure TMainForm.Lynx10Receive(Sender: TObject);
begin
  (* Get the String from the X10 Object *)
 // RXCommands.items.insert(0,strpas(Lynx10.RxString));
end;

procedure TMainForm.GetModeBtnClick(Sender: TObject);
begin
  Lynx10.RequestModeRegister;
end;

procedure TMainForm.SetDimModeClick(Sender: TObject);
begin
  Lynx10.DimMode:=SetDimMode.Checked;
end;

procedure TMainForm.SetDebugModeClick(Sender: TObject);
begin
  Lynx10.DebugMode:=SetDebugMode.Checked;
end;

procedure TMainForm.SetHandShakingModeClick(Sender: TObject);
begin
  Lynx10.SoftwarehandShakingMode:=SetHandShakingMode.Checked;
end;

procedure TMainForm.ManualBtnClick(Sender: TObject);
var
  tcstr   :array[0..8] of char;
begin
  if CRLF.checked then Command.text:=command.text+chr(13);
  strpcopy(tcstr,Command.text);
  Lynx10.SendString(strpas(tcstr));
  Command.text:='';
end;

procedure TMainForm.TerminatorsClick(Sender: TObject);
begin
  if terminators.itemindex=0 then Lynx10.TerminationMode:=TermWith_CR
  else if terminators.itemindex=1 then Lynx10.TerminationMode:=TermWith_LF
  else if terminators.itemindex=2 then Lynx10.TerminationMode:=TermWith_CRLF;
end;

procedure TMainForm.Lynx10Transmit(Sender: TObject);
begin
//  TXCommands.items.insert(0,strpas(Lynx10.TxString));
end;

procedure TMainForm.BadCommandsFromHost1Click(Sender: TObject);
begin
  Lynx10.RequestErrorCount(byte(TMenuItem(sender).tag));
end;


procedure TMainForm.BadCommandsFromHost2Click(Sender: TObject);
begin
  Lynx10.ClearErrorCount(byte(TMenuItem(sender).tag));
end;

procedure TMainForm.Version1Click(Sender: TObject);
begin
  Lynx10.RequestLynx10Version;
end;

procedure TMainForm.Copywrite1Click(Sender: TObject);
begin
  Lynx10.RequestLynx10Copywrite;
end;

procedure TMainForm.TurnOn1Click(Sender: TObject);
var
  h,d   :string[3];
begin
  h:=inttohex(housecodes.itemindex,1);
  d:=inttohex(devicecodes.itemindex,1);
  Lynx10.TurnOn(h,d)
end;

procedure TMainForm.TurnOnHouseCode1Click(Sender: TObject);
var
  h   :string[3];
begin
  h:=inttohex(housecodes.itemindex,1);
  Lynx10.TurnOnHouseCode(h);
end;

procedure TMainForm.TurnOnAll1Click(Sender: TObject);
begin
  Lynx10.TurnOnAll;
end;

procedure TMainForm.TurnOff1Click(Sender: TObject);
var
  h,d   :string[3];
begin
  h:=inttohex(housecodes.itemindex,1);
  d:=inttohex(devicecodes.itemindex,1);
  Lynx10.TurnOff(h,d);
end;

procedure TMainForm.TurnOffTurnOffHouseCodeLights1Click(Sender: TObject);
var
  h   :string[3];
begin
  h:=inttohex(housecodes.itemindex,1);
  Lynx10.TurnOffLightsHouseCode(h);
end;

procedure TMainForm.TurnOffAllHouseCode1Click(Sender: TObject);
begin
  Lynx10.TurnOffAllLights;
end;

procedure TMainForm.TurnOffAllHouseCode2Click(Sender: TObject);
var
  h   :string[3];
begin
  h:=inttohex(housecodes.itemindex,1);
  Lynx10.TurnOffHouseCode(h);
end;

procedure TMainForm.TurnOffAll1Click(Sender: TObject);
begin
  Lynx10.TurnOffAll;
end;

procedure TMainForm.DimToBtnClick(Sender: TObject);
var
  h,d,v   :string[3];
begin
  v:=inttohex(Lynx10Trackbar1.position,1);
  h:=inttohex(housecodes.itemindex,1);
  d:=inttohex(devicecodes.itemindex,1);
  Lynx10.DimTo(h,d,v);
end;

procedure TMainForm.DimUpHousecode1Click(Sender: TObject);
var
  h,d,v   :string[3];
begin
  v:=inttohex(StrToInt(DimAmount.Text),1);
  h:=inttohex(housecodes.itemindex,1);
  d:=inttohex(devicecodes.itemindex,1);
  Lynx10.DimUp(h,d,v);
end;

procedure TMainForm.DimDownHouseCode1Click(Sender: TObject);
var
  h,d,v   :string[3];
begin
  v:=inttohex(StrToInt(DimAmount.Text),1);
  h:=inttohex(housecodes.itemindex,1);
  d:=inttohex(devicecodes.itemindex,1);
  Lynx10.DimDown(h,d,v);
end;

procedure TMainForm.GetAllErrors1Click(Sender: TObject);
begin
  Lynx10.RequestErrorCount(0);
  Lynx10.RequestErrorCount(1);
  Lynx10.RequestErrorCount(2);
  Lynx10.RequestErrorCount(3);
  Lynx10.RequestErrorCount(4);
  Lynx10.RequestErrorCount(5);
  Lynx10.RequestErrorCount(6);
  Lynx10.RequestErrorCount(7);
end;

procedure TMainForm.CelarAllErrors1Click(Sender: TObject);
begin
  Lynx10.ClearErrorCount(0);
  Lynx10.ClearErrorCount(1);
  Lynx10.ClearErrorCount(2);
  Lynx10.ClearErrorCount(3);
  Lynx10.ClearErrorCount(4);
  Lynx10.ClearErrorCount(5);
  Lynx10.ClearErrorCount(6);
  Lynx10.ClearErrorCount(7);
  GetAllErrors1Click(self);
end;

procedure TMainForm.ResendThisCommand1Click(Sender: TObject);
var
  tcstr     :array[0..10] of char;
begin
  if TxCommands.itemindex>=0 then
  begin
    strpcopy(tcstr,TxCommands.items.strings[TxCommands.itemindex]);
    Lynx10.SendString(StrPas(tcstr));
  end;
end;

procedure TMainForm.Lynx10ReceiveData(Sender: TObject; Data: PChar;
  DataSize: Integer);
begin
  RxCommands.items.Insert(0,StrPas(Data));
end;

procedure TMainForm.Lynx10TransmitData(Sender: TObject; Data: PChar;
  DataSize: Integer);
begin
  TXCommands.items.insert(0,strpas(Data));
end;

procedure TMainForm.Lynx10RecErrorCount(Sender: TObject; Count,
  Data: integer);
begin
  case Data of
    0: editE0.text:=inttostr(count);
    1: editE1.text:=inttostr(count);
    2: editE2.text:=inttostr(count);
    3: editE3.text:=inttostr(count);
    4: editE4.text:=inttostr(count);
    5: editE5.text:=inttostr(count);
    6: editE6.text:=inttostr(count);
    7: editE7.text:=inttostr(count);
  end;  (* end case *)
end;

procedure TMainForm.Lynx10RecCopywrite(Sender: TObject);
begin
  Copyright.caption:=Lynx10.Lynx10Copywrite;
end;

procedure TMainForm.Lynx10RecModeRegister(Sender: TObject);
begin
  if Lynx10.DimMode=True then SetDimMode.checked:=true
  else SetDimMode.Checked:=false;
  if Lynx10.DebugMode=True then SetDebugMode.checked:=true
  else SetDebugMode.Checked:=false;
  if Lynx10.SoftwareHandShakingMode=True then SetHandShakingMode.checked:=true
  else SetHandShakingMode.Checked:=false;
  if Lynx10.TerminationMode=TermWith_CR then Terminators.itemindex:=0
  else if Lynx10.TerminationMode=TermWith_LF then Terminators.itemindex:=1
  else if Lynx10.TerminationMode=TermWith_CRLF then Terminators.itemindex:=2;
end;

procedure TMainForm.Lynx10RecVersion(Sender: TObject);
begin
  Version.caption:=Lynx10.Lynx10Version;
end;

procedure TMainForm.E8Click(Sender: TObject);
begin
  close;
end;

procedure TMainForm.Com1Click(Sender: TObject);
var
  c  :boolean;
begin
  c:=Lynx10.Connected;
  if Lynx10.Connected then Lynx10.DisConnect;
  x10_port:=integer(TMenuItem(sender).tag);
  case x10_port of
    1:  Lynx10.ComPort:=pn_COM1;
    2:  Lynx10.ComPort:=pn_COM2;
    3:  Lynx10.ComPort:=pn_COM3;
    4:  Lynx10.ComPort:=pn_COM4;
  end;  (* end case *)
  Com1.checked:=false;
  Com2.checked:=false;
  Com3.checked:=false;
  Com4.checked:=false;
  case Lynx10.ComPort of
    pn_COM1: Com1.checked:=true;
    pn_COM2: Com2.checked:=true;
    pn_COM3: Com3.checked:=true;
    pn_COM4: Com4.checked:=true;
  end;  (* end case *)
  if c then Lynx10.Connect;
end;

procedure TMainForm.Lynx10Connect(Sender: TObject);
begin
  C1.Caption:='Disconnect';
  case Lynx10.ComPort of
    pn_COM1: Com1.checked:=true;
    pn_COM2: Com2.checked:=true;
    pn_COM3: Com3.checked:=true;
    pn_COM4: Com4.checked:=true;
  end;  (* end case *)
end;

procedure TMainForm.Lynx10DisConnect(Sender: TObject);
begin
  C1.Caption:='Connect';
end;

procedure TMainForm.C1Click(Sender: TObject);
begin
  if not(Lynx10.Connected) then Lynx10.Connect
  else Lynx10.DisConnect;
end;

end.
