*
*  X2JSTFIL.PRG
*  Returns just the file name with or without extension
*  from a fully-qualified path plus file name
*
*  Copyright (c) 1996  (Public Domain) MaxTech, Inc. 
*                      MaxTech, Inc.
*                      8721C Plantation Lane, Suite 302
*                      Manassas, VA  20110
*                      703-369-1759
*  Author:  Drew Speedie
*
*  REQUIRES:
*  =================================
*  X2SETLIB.PRG if _WINDOWS=.t.
*
*
*  In _WINDOWS
*    uses FOXTOOLS.FLL/justfname()
*  In _DOS
*    does the work here 
*
*
*  Parameters
*    tcFileName (R) Path+Filename String to be parsed
*    tlNoExt    (O) Strip the extension?
*
*
*  USAGE:
*
*  ? x2jstfil(sys(2019))      &&& "CONFIG.FP" or "CONFIG.FPW", etc.
*  
*  ? x2jstfil(sys(2019),.t.)  &&& "CONFIG"
*
parameters tcFileName, tlNoExt
private lcRetVal, ;
        lnSlashPos, ;
        lnNameLen
lcRetVal = space(0)
DO CASE
  CASE _windows
    IF x2setlib("FOXTOOLS")
      lcRetVal = upper(justfname(tcFileName))
     ELSE
      * unable to load FOXTOOLS.FLL  
      lcRetVal = BrutForc(tcFileName)
    ENDIF
  OTHERWISE
    lcRetVal = BrutForc(tcFileName)
ENDCASE 
IF tlNoExt
  IF "." $ lcRetVal
    #IF "VISUAL"$upper(vers())
      lcRetval = leftc(lcRetVal,at_c(".",lcRetVal)-1)
     #ELSE
      lcRetval = left(lcRetVal,at(".",lcRetVal)-1)
    #ENDIF
  ENDIF
ENDIF

return upper(alltrim(lcRetVal))



PROCEDURE BrutForc
parameters tcFileName
private lnSlashPos, lnNameLen, lcRetVal, lnColonPos
lcRetVal = tcFileName
#IF "VISUAL"$upper(vers())
  lnSlashPos = ratc("\",tcFileName)
#ELSE
  lnSlashPos = rat("\",tcFileName)
#ENDIF
IF lnSlashPos > 0
  #IF "VISUAL"$upper(vers())
    lnNameLen  = lenc(tcFileName) - lnSlashPos
    lcRetVal = rightc(tcFileName, lnNameLen)
  #ELSE
    lnNameLen  = len(tcFileName) - lnSlashPos
    lcRetVal = right(tcFileName, lnNameLen)
  #ENDIF
ENDIF
#IF "VISUAL"$upper(vers())
  lnColonPos = ratc(":",lcRetVal)
#ELSE
  lnColonPos = rat(":",lcRetVal)
#ENDIF
IF lnColonPos > 0
  #IF "VISUAL"$upper(vers())
    lnNameLen  = lenc(lcRetVal) - lnColonPos
    lcRetVal   = rightc(lcRetVal,lnNameLen)
  #ELSE
    lnNameLen  = len(lcRetval) - lnColonPos
    lcRetVal   = right(lcRetVal,lnNameLen)
  #ENDIF
ENDIF
return lcRetVal



PROCEDURE keywords
* MISCELLANEOUS 
return