*
*  X2SETLIB.PRG
*  SET LIBRARY TO the passed library 
*
*  RETURNs a logical value indicating success
*
*
*  Copyright (c) 1996  (Public Domain) MaxTech, Inc. 
*                      MaxTech, Inc.
*                      8721C Plantation Lane, Suite 302
*                      Manassas, VA  20110
*                      703-369-1759
*  Author:  Tom DeMay
*
*  Usage:
*    IF x2setlib("FOXTOOLS")
*      * FOXTOOLS.FLL was successfully installed
*     ELSE
*      * FOXTOOLS.FLL could not be successfully installed
*      do x3winmsg with "Cannot continue without FoxTools.fll"
*      quit
*    ENDIF
*    
*  Parameters
*     tcLibrary (R) Name of library (.FLL/.PLB) to SET LIBRARY TO
*                   NOTE:  if you only pass the filename, no extension
*                          the ".FLL" or ".PLB" extension is assumed,
*                          based on the value of _DOS/_WINDOWS      
*
* 
parameters tcLibrary
private pcOnError, plSuccess

IF type("tcLibrary") = "C" AND !empty(tcLibrary)
  tcLibrary = upper(alltrim(tcLibrary))
  IF "." $ tcLibrary
   ELSE
    IF _DOS
      tcLibrary = tcLibrary + ".PLB"
     ELSE
      tcLibrary = tcLibrary + ".FLL"
    ENDIF
  ENDIF
 ELSE
  return .f.
ENDIF

IF tcLibrary $ set("LIBRARY")
  * tcLibrary is already loaded, no need to continue
  return .t.
ENDIF

pcOnError = on("ERROR")
plSuccess = .t.
on error plSuccess = .f.

IF file(sys(2004)+ tcLibrary)
  * the library is in the FoxPro directory
  set library to (sys(2004) + tcLibrary) additive
 ELSE
  set library to (tcLibrary) additive
ENDIF

on error &pcOnError

return plSuccess
	