*
*  X2WEXIST.PRG
*  Test for the existence of a Windows application
*  by checking to see if the passed main window
*  title exists 
*
*  Copyright (c) 1996  (Public Domain) MaxTech, Inc. 
*                      MaxTech, Inc.
*                      8721C Plantation Lane, Suite 302
*                      Manassas, VA  20110
*                      703-369-1759
*  Author:  Drew Speedie
*
*
*
*  Usage:
*    lcTitle = "My Application"
*    IF x2wexist(lcTitle)
*      do x3winmsg with lcTitle + ;
*           " is already running in another session " + ;
*           "-- multiple sessions are now allowed"
*      quit 
*    ENDIF
*    
*    ? x2wexist("PROGRAM MANAGER")
*    ? x2wexist("microsoft word - document1")
*    ? x2wexist("Microsoft FoxPro")
*  
*  REQUIRES
*  =========================
*  X2SETLIB.PRG
*  FOXTOOLS.FLL
*
*  
*  Parameters
*    tcWinTitle (R) Window title to be checked (case insensitive)
*
parameters tcWinTitle
IF x2setlib("FOXTOOLS")
 ELSE
  return .f.
ENDIF
#IF "VISUAL" $ upper(vers())
  local lnRegFn, lnWinClass, lnHandle
  DECLARE INTEGER FindWindow IN user32.dll;
          STRING @lnWinClass, ;
          STRING @tcWinTitle
  lnWinClass = 0
  lnHandle = FindWindow(lnWinClass,tcWinTitle)
#ELSE
  private lnRegFn, lnWinClass, lnHandle
  *
  *  NOTE:
  *  Several folks report that without the following inkey() delay,
  *  they get kicked out of FoxPro (usually VFP), sometimes with an
  *  Unhandled Exception Error
  *
  =inkey(.05)
  lnRegFn    = regfn("FindWindow","CC","I")
  lnWinClass = 0
  lnHandle   = callfn(lnRegFn, lnWinClass, tcWinTitle)
#ENDIF
return lnHandle > 0

