*
*  X3CPEDIG.PRG
*  Answers the question:  Does the passed toObject have the
*  passed tcClassName in its pedigree?  Or:  Is tcClassName
*  somewhere in the ancestry of toObject?
*
*  Copyright (c) 1996  (Public Domain) MaxTech, Inc. 
*                      MaxTech, Inc.
*                      8721C Plantation Lane, Suite 302
*                      Manassas, VA  20110
*                      703-369-1759
*  Author:  Drew Speedie
*
*
*  lParameters
*       toObject (R) Object reference to the object whose pedigree
*                    is to be checked
*    tcClassName (R) Check the ACLASS() pedigree of toObject for
*                    this class name
*
*  Usage:
*
*  * from form method code:
*  IF x3cpedig(THIS,"FRMBASE")
*    * THISFORM is a form from the X3FW.VCX/frmBase class hierarchy
*   ELSE
*    * THISFORM does not inherit from X3FW.VCX/frmBase
*  ENDIF
*
*  * from textbox method code:
*  IF x3cpedig(THIS,"txtBound")
*    * THIS textbox is from the X3FWCTRL.VCX/txtBound class hierarchy
*   ELSE
*    * THIS textbox does not inherit from X3FW.VCX/txtBound
*  ENDIF
*
lparameters toObject, tcClassName

IF type("toObject") = "O" AND !isnull(toObject)
 ELSE
  return .f.
ENDIF

IF type("tcClassName") = "C" AND !empty(tcClassName)
  tcClassName = upper(alltrim(tcClassName))
 ELSE
  return .f.
ENDIF

local laClass[1], llRetVal

IF aclass(laClass,toObject) > 0
  do x3setcls with "X3FWPPOP.VCX" 
  local loExact
  loExact = createobject("cusPushPopSetOnOff","EXACT")
  set exact on
  llRetVal = ascan(laClass,tcClassName)>0
ENDIF

return llRetVal
