*
*  X3GETVER.PRG
*  Returns the VFP version executing this code
*  as an integer, 3 or 5
*  
*
*  Copyright (c) 1996  (Public Domain) MaxTech, Inc. 
*                      MaxTech, Inc.
*                      8721C Plantation Lane, Suite 302
*                      Manassas, VA  20110
*                      703-369-1759
*  Author:  Drew Speedie
*
*
*  Usage:
*    IF x3getver() = 3
*      * VFP3.0b-specific code goes here
*     ELSE
*      * VFP5.0-specific code goes here
*    ENDIF
*
*
local lnVersion
DO CASE
  CASE type("_VFP") = "U"
    lnVersion = 3
  CASE type("_VFP") = "O"
    lnVersion = 5

  *
  *  future versions of VFP may require
  *  additional CASEs here
  *

ENDCASE
*
*  if, for some unexplained reason, lnVersion hasn't
*  been set, your calling code will blow up...
*
return lnVersion




**** old version

local lcString, lnVersion, xx
lcVersion = upper(alltrim(version()))
lcVersion = strtran(lcVersion,"VISUAL FOXPRO",space(0))
lcString  = space(0)
FOR xx = 1 to lenc(lcVersion)
  IF empty(chrtranc(substrc(lcVersion,xx,1),"1234567890.",""))
    lcString = lcString + substrc(lcVersion,xx,1)
  ENDIF
  IF !empty(lcString) AND empty(substrc(lcVersion,xx,1))
    exit
  ENDIF
ENDFOR
IF occurs(".",lcString) > 0
  lcVersion = leftc(lcString,at_c(".",lcVersion)-1)
 ELSE
  lcVersion = lcString
ENDIF
return int(val(lcVersion))
