*
*  X3WRPFRM.PRG
*  Calls the passed .VCX-based modal form 
*  and RETURNs a value set in the form.
*
*  NOTE:  the .VCX-based modal form is required to
*         manipulate the puX3wrpfrm private memvar
*         created here and visible there.  It's the
*         puX3wrpfrm memvar that is "returned" to
*         this .PRG and to your X3WRPFRM() call.
*
*
*  Copyright (c) 1996  (Public Domain) MaxTech, Inc. 
*                      MaxTech, Inc.
*                      8721C Plantation Lane, Suite 302
*                      Manassas, VA  20110
*                      703-369-1759
*  Author:  Drew Speedie
*
*
*  USAGE: 
*  local xx
*  xx = x3wrpfrm("frmReportDestination")
*  xx = x3wrpfrm("frmReportDestination,x3fw")
*  xx = x3wrpfrm("frmReportDestination,x3fw",["PS"])
*  xx = x3wrpfrm("frmReportDestination,x3fw",["PF","Form Title"])
*
*
*  lParameters
*     tcClassName (R) Class Name of the .VCX-based 
*                     form to be executed.  You may
*                     optionally include a comma-
*                     delimited .VCX file name to 
*                     SET CLASSLIB TO.
*    tcParameters (O) Character string containing
*                     parameters to be sent to the
*                     form.
*
lparameters tcClassName, tcParameters

IF type("tcClassName") = "C" AND !empty(tcClassName)
  local lcClassName
  lcClassName = upper(alltrim(tcClassName))
 ELSE
  return .NULL.
ENDIF
IF "," $ lcClassName
  local lcClassLib 
  lcClassLib = substrc(lcClassName,at_c(",",lcClassName)+1)
  IF !empty(lcClassLib)
    set classlib to (lcClassLib) additive  
  ENDIF
  lcClassName = leftc(lcClassName,at_c(",",lcClassName)-1)
ENDIF
local lcParameters
IF type("tcParameters") = "C" AND !empty(tcParameters)
  lcParameters = alltrim(tcParameters)
 ELSE
  lcParameters = space(0)
ENDIF

private puX3wrpfrm
puX3wrpfrm = .NULL.

local loForm
IF empty(lcParameters)
  loForm = createobject(lcClassName)
 ELSE
  loForm = createobject(lcClassName,&lcParameters)
ENDIF
IF type("loForm") = "O" AND !isnull(loForm)
  loForm.Show()
ENDIF

return puX3wrpfrm
  